local os = require( 'os' )
local srcdir = os.getenv('srcdir') or '.'

local intrinsic = require( 'saotrace.raygen.mock_intrinsics' )
local load_sources = require( 'saotrace.raygen.source.load' ).load_sources
local va = require('validate.args')

function srcfile( name )

   return table.concat( { srcdir, 'tests', 'data', name}, '/' )..'.xml'

end

describe( "load sources", function ()

             before_each( function ()
                   getmetatable( require('saotrace.config') ).reset()
                   va.reset()
                   va.opts{ check_spec = true,
                            error_on_bad_spec = true,
                   }
                   intrinsic.stash = {}
             end)


             it( "load_it", function ( )

                    
                    assert.has_no.error(
                       function () load_sources( srcfile('sources') )
                    end )

             end)

             it( "load_bad1", function ( )

                    assert.error_matches(
                       function ()  load_sources( srcfile('bad1') ) end,
                       "only one position"
                    )

             end)

             it( "load_bad2", function ( )

                    assert.error_matches(
                       function () load_sources( srcfile('bad2') ) end,
                       "extent: required but not specified"
                    )

             end)

             it( "load_bad3", function ( )

                    assert.error_matches(
                       function () load_sources( srcfile('bad3') ) end,
                       "only one extent"
                    )

             end)

             it( "load_bad4", function ( )

                    assert.error_matches(
                       function () load_sources( srcfile('bad4') ) end,
                       "fluffy_bunny"
                    )

             end)

             it( "load_bad5", function ( )

                    assert.error_matches(
                       function () load_sources( srcfile('bad5') ) end,
                       "mangy_rabbit"
                    )

             end)

end)
